/*****************************************************************************
 * This program provides a simple example of a recursive function definition. 
 * The factorial of a non-negative integer 'n' is the product of '1' with all 
 * the integers between '1' and 'n' inclusive. Among many other applications, 
 * The function is useful in expressing Taylor series in calculus.
 ******************************************************************************/

#include<iostream>
#include<stdexcept>
#include<vector>
#include<algorithm>
using std::cout; using std::cin; using std::endl;
using std::domain_error; using std::vector;
using std::swap;
typedef vector<int>::size_type v_size;

/* This displays the elements a of vector separated by spaces. */
 template <class T>
 void show(const vector<T>& v)
{
	typedef typename vector<T>::size_type v_size;
	for(v_size i=0; i<v.size(); i++)
		cout<<v[i]<<" ";
}

void permutations(vector<int> v, v_size i)
{
	if(i==v.size()-1)
	{
		cout<<"(";
		show(v);
		cout<<") "<<endl;
		return;
	}
	else
		for(v_size j=i;j!=v.size();j++)
		{
			swap(v[i],v[j]);
			permutations(v, i+1);
		}
					
			
}
	

int main()
{
	vector<int> vec;
	for(int i=1; i!=5; i++)
		vec.push_back(i);
	permutations(vec, 0);
	return 0;
}

